/********************************************************************
*  This header file is included by the header file ML6RTBIB.H.
*  Its purpose is to declare all prototypes of procedures exported
*  by the library ML6RTBIB.
*
*  Hints:
*  The library imports and exports strings as null-terminated
*  strings. Each function that imports or exorts such a string
*  is declared as 'Cname'.
*
*  Defines for Preprocessor:
*  __BUILD_RTBIB__      Exclusive to build the library
*
*  Author        HK
*
*
*  Last change   21/06/2000
*                New Prototypes mdd6_entry_callback and
*                               mdd6_exit_callback
*                               ml6rt_chm_init_config
*                               ml6rt_chm_open_channel
*                               ml6rt_chm_open_channel_callback
*                               ml6rt_get_par_sema
*                               ml6rt_reset_par_sema
*                               ml6rt_read_data_offs
*                               ml6rt_write_data_offs
*                               ml6rt_entry_function_phys
*                               ml6rt_exit_function_phys
*
*  Last change   22/09/98
*                Prototypes ml6rt_get_date_and_time_2000 and
*                           ml6rt_set_date_and_time_2000 added
*
*  Author        Dipl.-Ing. H.Doersam
*
*  Last change   06/05/98
*
*  Copyrights by SORCUS Computer GmbH 1998
*  All rights reserved.
********************************************************************/



#ifndef _INC_ML6RTPRO
#define _INC_ML6RTPRO



/********************************************************************
*  Prepare
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_set_pdt_adr (VOID* pPDT);



/********************************************************************
*  Version
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_get_lib_version
   (ULONG* pulVersion, ULONG* pulDate);

RTBIBAPI VOID PFAR ml6rt_get_osx_version
   (ULONG* pulVersion, ULONG* pulDate);



/********************************************************************
*  Error handling
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_set_error_handler (VOID* pfnErrHan);

RTBIBAPI VOID PFAR ml6rt_default_error_handler (VOID);

RTBIBAPI VOID PFAR ml6rt_get_error_info
   (ML6RT_ERROR_INFO_TYPE* prcError);

RTBIBAPI USHORT PFAR ml6rt_get_error_counter (VOID);

RTBIBAPI VOID PFAR ml6rt_reset_error (VOID);

RTBIBAPI VOID PFAR ml6rt_set_mark (USHORT usMark);

RTBIBAPI VOID PFAR ml6rt_error_event (USHORT usClass, USHORT usCode);

RTBIBAPI VOID PFAR ml6rt_force_error (VOID);

RTBIBAPI VOID PFAR ml6rt_call_error_handler (VOID);

RTBIBAPI USHORT PFAR ml6rt_control_error_handling (USHORT usCtrl);

// ml6rt_error_flag changes to 1 when a library call fails. With
// ml6rt_reset_error() the flag falls down to 0. It can be used to
// poll an error, but normally it is more	efficient to install an
// error handler (with ml6rt_set_error_handler)
#ifndef __BUILD_RTBIB__
EXTERNAL USHORT ml6rt_err_flag;
#endif // !__BUILD_RTBIB__



/********************************************************************
*  Address converting
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_phys_adr (VOID* pSegOff, ULONG* pulPhys);

RTBIBAPI VOID PFAR ml6rt_real_adr (ULONG ulPhys, VOID* pPtr);



/********************************************************************
*  Interrupting program sequences
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_disable_interruptible (VOID);

RTBIBAPI VOID PFAR ml6rt_enable_interruptible (VOID);



/********************************************************************
*  Delay procedure
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_delay (ULONG ulDelay);

RTBIBAPI VOID PFAR ml6rt_wait (VOID);


/********************************************************************
*  String handling
********************************************************************/

RTBIBAPI VOID PFAR Cml6rt_create_version_string
   (CHAR* pacStr, ULONG ulData);

RTBIBAPI VOID PFAR Cml6rt_create_date_string
   (CHAR* pacStr, ULONG ulData);

RTBIBAPI VOID PFAR Cml6rt_create_time_string
   (CHAR* pacStr, ULONG ulData);

RTBIBAPI VOID PFAR Cml6rt_create_micro_time_string
   (CHAR* pacStr, MICRO_TIME_CODE* prcData);

RTBIBAPI VOID PFAR Cml6rt_strcpy (CHAR* pcDest, CHAR* pcSrc);

RTBIBAPI USHORT PFAR Cml6rt_strlen (CHAR* pacStr);

RTBIBAPI VOID PFAR Cml6rt_strncat (CHAR* pcDest, CHAR* pcSrc);

RTBIBAPI VOID PFAR ml6rt_c_string (CHAR* pacStr);

RTBIBAPI VOID PFAR ml6rt_pascal_string (CHAR* pacStr);


// String imports and exports, no conversation necessary
#define ml6rt_create_version_string Cml6rt_create_version_string
#define ml6rt_create_date_string Cml6rt_create_date_string
#define ml6rt_create_time_string Cml6rt_create_time_string
#define ml6rt_create_micro_time_string Cml6rt_create_micro_time_string
#define ml6rt_strcpy Cml6rt_strcpy
#define ml6rt_strncat Cml6rt_strncat
#define ml6rt_strlen Cml6rt_strlen



/********************************************************************
*  Task procedures
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_entry (VOID);

RTBIBAPI USHORT PFAR ml6rt_entry_task (VOID);

RTBIBAPI VOID PFAR ml6rt_exit (VOID);

RTBIBAPI VOID PFAR ml6rt_exit_interrupt (VOID);

RTBIBAPI VOID PFAR ml6rt_get_proc_address
   (USHORT usTask, USHORT usProc, VOID* pfnProc);

RTBIBAPI VOID PFAR ml6rt_call_proc (USHORT usTask, USHORT usProc);



/********************************************************************
*  Task functions
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_entry_function (VOID);

RTBIBAPI VOID PFAR ml6rt_entry_function_phys (VOID);

RTBIBAPI VOID PFAR ml6rt_exit_function
   (USHORT usUnused, USHORT usReturned, USHORT usError);

RTBIBAPI VOID PFAR ml6rt_exit_function_phys
   (USHORT usUnused, USHORT usReturned, USHORT usError);

RTBIBAPI VOID PFAR ml6rt_call_func
   (USHORT usTask, USHORT usFunc,
   USHORT* pusSizeIn, VOID* pDataIn,
   USHORT usOutMax, USHORT* pusSizeOut, VOID* pDataOut,
   USHORT* pusError);



/********************************************************************
*  Read/Write task parameter
********************************************************************/

RTBIBAPI USHORT PFAR ml6rt_get_par_sema (USHORT usTask);

RTBIBAPI VOID PFAR ml6rt_reset_par_sema (USHORT usTask);

RTBIBAPI UCHAR PFAR ml6rt_read_par_byte 
   (USHORT usTask, USHORT usRelOfs);

RTBIBAPI USHORT PFAR ml6rt_read_par_word
   (USHORT usTask, USHORT usRelOfs);

RTBIBAPI VOID PFAR ml6rt_read_par_dword
   (USHORT usTask, USHORT usRelOfs, ULONG* pulData);

RTBIBAPI VOID PFAR ml6rt_read_par_block
   (USHORT usTask, USHORT usRelOfs, USHORT usSize, VOID* pData);

RTBIBAPI VOID PFAR ml6rt_write_par_byte
   (USHORT usTask, USHORT usRelOfs, UCHAR ucData);

RTBIBAPI VOID PFAR ml6rt_write_par_word
   (USHORT usTask, USHORT usRelOfs, USHORT usData);

RTBIBAPI VOID PFAR ml6rt_write_par_dword
   (USHORT usTask, USHORT usStart, ULONG ulData);

RTBIBAPI VOID PFAR ml6rt_write_par_block
   (USHORT usTask, USHORT usRelOfs, USHORT usSize, VOID* pData);

RTBIBAPI VOID PFAR ml6rt_get_par_address
   (USHORT usTask, USHORT usRelOfs, ULONG* pulParAdr);



/********************************************************************
*  Read/Write task data
********************************************************************/

RTBIBAPI USHORT PFAR ml6rt_get_data_sema (USHORT usTask);

RTBIBAPI VOID PFAR ml6rt_reset_data_sema (USHORT usTask);

RTBIBAPI VOID PFAR ml6rt_reset_r_pointer (USHORT usTask);

RTBIBAPI VOID PFAR ml6rt_move_r_pointer (USHORT usTask, LONG lMoves);

RTBIBAPI UCHAR PFAR ml6rt_read_data_byte (USHORT usTask);

RTBIBAPI USHORT PFAR ml6rt_read_data_word (USHORT usTask);

RTBIBAPI VOID PFAR ml6rt_read_data_dword 
   (USHORT usTask, ULONG* pulData);

RTBIBAPI VOID PFAR ml6rt_read_data_block
   (USHORT usTask, USHORT usSize, VOID* pData);

RTBIBAPI VOID PFAR ml6rt_read_data
   (USHORT usTask, ULONG ulRelOfs, USHORT usSize, VOID* pData);

RTBIBAPI VOID PFAR ml6rt_read_data_offs
   (USHORT usTask, ULONG ulStart, USHORT usSize, VOID* pData);


RTBIBAPI VOID PFAR ml6rt_reset_w_pointer (USHORT usTask);

RTBIBAPI VOID PFAR ml6rt_move_w_pointer (USHORT usTask, LONG lMoves);

RTBIBAPI VOID PFAR ml6rt_write_data_byte
   (USHORT usTask, UCHAR ucData);

RTBIBAPI VOID PFAR ml6rt_write_data_word
   (USHORT usTask, USHORT usData);

RTBIBAPI VOID PFAR ml6rt_write_data_dword
   (USHORT usTask, ULONG ulData);

RTBIBAPI VOID PFAR ml6rt_write_data_block
   (USHORT usTask, USHORT usSize, VOID* pData);

RTBIBAPI VOID PFAR ml6rt_write_data
   (USHORT usTask, ULONG ulRelOfs, USHORT usSize, VOID* pData);

RTBIBAPI VOID PFAR ml6rt_write_data_offs
   (USHORT usTask, ULONG ulStart, USHORT usSize, VOID* pData);


/********************************************************************
*  Control a task
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_wakeup_task (USHORT usTask);

RTBIBAPI VOID PFAR ml6rt_wakeup_ni_task 
   (USHORT usTask, USHORT usPrior);

RTBIBAPI VOID PFAR ml6rt_wakeup_ti_task
   (USHORT usTask, UCHAR ucPrior, ULONG ulCount, ULONG ulInterval,
   ULONG ulHoldOff);

RTBIBAPI VOID PFAR ml6rt_sleep_task (USHORT usTask);

RTBIBAPI VOID PFAR ml6rt_install_task (ULONG ulInsRec);



/********************************************************************
*  Get task information
********************************************************************/

RTBIBAPI UCHAR PFAR ml6rt_prog_in_rom (USHORT usPrg);

RTBIBAPI VOID PFAR ml6rt_get_task_info
   (USHORT usTask, USHORT usCallNr, ULONG* pulInfo);

RTBIBAPI UCHAR PFAR ml6rt_get_task_status (USHORT usTask);

RTBIBAPI VOID PFAR ml6rt_get_int_task
   (USHORT usInt, USHORT* pusTask, UCHAR* pucType);

RTBIBAPI USHORT PFAR ml6rt_get_task_number 
   (USHORT usPrg, USHORT* pusInst);

RTBIBAPI VOID PFAR ml6rt_get_tdt_address (USHORT usTask, VOID* pTDT);



/********************************************************************
*  Send service request to host
********************************************************************/

RTBIBAPI USHORT PFAR ml6rt_send_host_srq (USHORT usData);

RTBIBAPI VOID PFAR ml6rt_send_buffer_srq 
   (USHORT usData, USHORT usMode);



/********************************************************************
*  Local interrupts
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_mask_int (UCHAR ucInt);

RTBIBAPI VOID PFAR ml6rt_unmask_int (UCHAR ucInt);

RTBIBAPI VOID PFAR ml6rt_clear_int (UCHAR ucInt);

RTBIBAPI VOID PFAR ml6rt_end_of_int (UCHAR ucInt);

RTBIBAPI VOID PFAR ml6rt_set_int_edge (UCHAR ucInt, UCHAR ucEdge);

RTBIBAPI VOID PFAR ml6rt_set_int_vec (USHORT usInt, VOID* pfnISR);

RTBIBAPI VOID PFAR ml6rt_get_int_vec (USHORT usInt, VOID* pfnISR);



/********************************************************************
*  LEDs
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_local_led_on (VOID);

RTBIBAPI VOID PFAR ml6rt_local_led_off (VOID);

RTBIBAPI VOID PFAR ml6rt_external_led_on (VOID);

RTBIBAPI VOID PFAR ml6rt_external_led_off (VOID);



/********************************************************************
*  Read/Write EEPROM
********************************************************************/

RTBIBAPI USHORT PFAR ml6rt_read_eeprom_copy
   (UCHAR ucDevice, UCHAR ucWordNo);

RTBIBAPI USHORT PFAR ml6rt_read_eeprom_direct
   (UCHAR ucDevice, UCHAR ucWordNo);

RTBIBAPI VOID PFAR ml6rt_write_eeprom_copy
   (UCHAR ucDevice, UCHAR ucWordNo, USHORT usData);

RTBIBAPI VOID PFAR ml6rt_write_eeprom_direct
   (UCHAR ucDevice, UCHAR ucWordNo, USHORT usData);



/********************************************************************
*  Initialization of MODULAR-4 board or modules
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_init_io (UCHAR ucDevice, UCHAR ucMode);



/********************************************************************
*  Watchdog
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_trigger_watchdog (VOID);



/********************************************************************
*  Real-Time-Clock
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_set_rtc_mode (UCHAR ucMode);

RTBIBAPI UCHAR PFAR ml6rt_get_rtc_status (VOID);

RTBIBAPI VOID PFAR ml6rt_set_date_and_time
   (USHORT usYear, USHORT usMonth, USHORT usDay, USHORT usDOW,
   USHORT usHour, USHORT usMin, USHORT usSec);

RTBIBAPI VOID PFAR ml6rt_set_date_and_time_2000
   (USHORT usYear, USHORT usMonth, USHORT usDay, USHORT usDOW,
   USHORT usHour, USHORT usMin, USHORT usSec);

RTBIBAPI VOID PFAR ml6rt_get_date_and_time
   (USHORT* pusYear, USHORT* pusMonth, USHORT* pusDay,
   USHORT* pusDOW, USHORT* pusHour, USHORT* pusMin, USHORT* pusSec);

RTBIBAPI VOID PFAR ml6rt_get_date_and_time_2000
   (USHORT* pusYear, USHORT* pusMonth, USHORT* pusDay,
   USHORT* pusDOW, USHORT* pusHour, USHORT* pusMin, USHORT* pusSec);

RTBIBAPI ULONG PFAR ml6rt_get_rtc_date_code (VOID);

RTBIBAPI ULONG PFAR ml6rt_get_rtc_time_code (VOID);



/********************************************************************
*  Timer
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_set_timer
   (UCHAR ucTimer, USHORT usCounter, UCHAR ucMode);

RTBIBAPI USHORT PFAR ml6rt_convert_timer_data (ULONG ulTime);

RTBIBAPI VOID PFAR ml6rt_get_timer
   (UCHAR ucTimer, USHORT* pusCounter, UCHAR* pucStatus);



/********************************************************************
*  Processor control
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_cache_control (UCHAR ucMode);

RTBIBAPI VOID PFAR ml6rt_store_80487 (VOID);

RTBIBAPI VOID PFAR ml6rt_restore_80487 (VOID);

RTBIBAPI VOID PFAR ml6rt_init_fpu (USHORT usMask);



/********************************************************************
*  Local RAM
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_allocate_ram
   (USHORT usTask, USHORT usUsage, UCHAR ucStrategy, UCHAR ucAlign,
   ULONG* pulSize, ULONG* pulAdr);

RTBIBAPI VOID PFAR ml6rt_get_free_ram_size 
   (UCHAR ucAlign, ULONG* pulSize);

RTBIBAPI VOID PFAR ml6rt_read_ram
   (USHORT usSize, ULONG ulSrcAdr, VOID* pData);

RTBIBAPI VOID PFAR ml6rt_write_ram
   (USHORT usSize, ULONG ulDestAdr, VOID* pData);

RTBIBAPI VOID PFAR ml6rt_copy_ram
   (USHORT usSize, VOID* pDest, VOID* pSrc);



/********************************************************************
*  Flash programming
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_set_flash_mode
   (UCHAR ucDevNo, UCHAR ucICNo, UCHAR ucMode, UCHAR ucOption);

RTBIBAPI USHORT PFAR ml6rt_get_flash_info
   (UCHAR ucDevNo, UCHAR ucICNo, UCHAR ucMode, UCHAR ucOption);

RTBIBAPI USHORT PFAR ml6rt_erase_flash_sector
   (UCHAR ucDevNo, UCHAR ucICNo, ULONG ulFirstAdr, ULONG ulLastAdr);

RTBIBAPI VOID PFAR ml6rt_program_flash
   (UCHAR ucDevNo, UCHAR ucICNo, ULONG ulStartAdr,
   USHORT usSize, VOID* pData);

RTBIBAPI VOID PFAR ml6rt_read_flash
   (UCHAR ucDevNo, UCHAR ucICNo, ULONG ulStartAdr,
   USHORT usSize, VOID* pData);



/********************************************************************
*  Buffer
********************************************************************/

RTBIBAPI HBUF6 PFAR ml6rt_create_buffer
   (USHORT usTask, UCHAR ucStrategy, UCHAR ucAlign, USHORT usUsage,
   ULONG* pulSize);

RTBIBAPI VOID PFAR ml6rt_get_buffer_status
   (HBUF6 hBuffer, ULONG* pulFree, ULONG* pulUsed);

RTBIBAPI VOID PFAR ml6rt_clear_buffer (HBUF6 hBuffer);

RTBIBAPI USHORT PFAR ml6rt_write_buffer_byte
   (HBUF6 hBuffer, UCHAR ucData);

RTBIBAPI USHORT PFAR ml6rt_write_buffer_word
   (HBUF6 hBuffer, USHORT usData);

RTBIBAPI USHORT PFAR ml6rt_write_buffer_dword
   (HBUF6 hBuffer, ULONG ulData);

RTBIBAPI USHORT PFAR ml6rt_write_buffer_block
   (HBUF6 hBuffer, USHORT usSize, VOID* pData);

RTBIBAPI USHORT PFAR ml6rt_write_buffer_max
   (HBUF6 hBuffer, USHORT* pusSize, VOID* pData);

RTBIBAPI USHORT PFAR ml6rt_read_buffer_byte
   (HBUF6 hBuffer, UCHAR* pucData);

RTBIBAPI USHORT PFAR ml6rt_read_buffer_word
   (HBUF6 hBuffer, USHORT* pusData);

RTBIBAPI USHORT PFAR ml6rt_read_buffer_dword
   (HBUF6 hBuffer, ULONG* pulData);

RTBIBAPI USHORT PFAR ml6rt_read_buffer_block
   (HBUF6 hBuffer, USHORT usSize, VOID* pData);

RTBIBAPI USHORT PFAR ml6rt_read_buffer_max
   (HBUF6 hBuffer, USHORT* pusSize, VOID* pData);

RTBIBAPI USHORT PFAR ml6rt_view_buffer_block
   (HBUF6 hBuffer, USHORT usSize, VOID* pData);

RTBIBAPI USHORT PFAR ml6rt_view_buffer_max
   (HBUF6 hBuffer, USHORT* pusSize, VOID* pData);



/********************************************************************
*  MODULAR-Device-Drivers
********************************************************************/

RTBIBAPI HMDD6 PFAR mdd6_open_channel
   (USHORT usMDD, USHORT usStrucSize, VOID* pCPS);

RTBIBAPI HMDD6 PFAR mdd6_open_channel_callback
   (USHORT usMDD, USHORT usStrucSize, VOID* pCPS,
    ULONG ulPar, void *pCbFunc, USHORT mode);

RTBIBAPI VOID PFAR mdd6_get_version
   (USHORT usMDD, ULONG* pulVersion, ULONG* pulDate);

RTBIBAPI VOID PFAR Cmdd6_read_infotext
   (USHORT usMDD, USHORT usTxtNr, UCHAR ucMaxLen, CHAR* pacInfotext);
// String import, no conversation neccesary
#define mdd6_read_infotext Cmdd6_read_infotext

RTBIBAPI USHORT PFAR mdd6_get_device_status
   (USHORT usMDD, USHORT usDevice, USHORT usIndex,
   USHORT usExtIndex);

RTBIBAPI USHORT PFAR mdd6_scan_channel
   (USHORT usMDD, USHORT usInfoType, HMDD6 hChannel,
   USHORT usCount, VOID* pInfoData);

RTBIBAPI VOID PFAR mdd6_reset_driver (USHORT usMDD);

RTBIBAPI VOID PFAR mdd6_write_channel_byte
   (HMDD6 hChannel, UCHAR ucData);

RTBIBAPI VOID PFAR mdd6_write_channel_word
   (HMDD6 hChannel, USHORT usData);

RTBIBAPI VOID PFAR mdd6_write_channel_short
   (HMDD6 hChannel, SHORT sData);

RTBIBAPI VOID PFAR mdd6_write_channel_dword
   (HMDD6 hChannel, ULONG ulData);

RTBIBAPI USHORT PFAR mdd6_write_channel_block
   (HMDD6 hChannel, USHORT usCount, VOID* pData);

RTBIBAPI VOID PFAR mdd6_trigger_channel (HMDD6 hChannel);

RTBIBAPI UCHAR PFAR mdd6_read_channel_byte (HMDD6 hChannel);

RTBIBAPI USHORT PFAR mdd6_read_channel_word (HMDD6 hChannel);

RTBIBAPI SHORT PFAR mdd6_read_channel_short (HMDD6 hChannel);

RTBIBAPI ULONG PFAR mdd6_read_channel_dword (HMDD6 hChannel);

RTBIBAPI USHORT PFAR mdd6_read_channel_block
   (HMDD6 hChannel, USHORT usCount, VOID* pData);

RTBIBAPI VOID PFAR mdd6_send_channel_command
   (HMDD6 hChannel, USHORT usCmd);

RTBIBAPI VOID PFAR mdd6_send_channel_control
   (HMDD6 hChannel, USHORT usCtrl, ULONG ulCtrlData);

RTBIBAPI USHORT PFAR mdd6_send_channel_control_block
   (HMDD6 hChannel, USHORT usCtrl, USHORT usSize, VOID* pCtrlData);

RTBIBAPI ULONG PFAR mdd6_get_channel_info
   (HMDD6 hChannel, USHORT usInfo);

RTBIBAPI USHORT PFAR mdd6_get_channel_info_block
   (HMDD6 hChannel, USHORT usInfo, USHORT usSize, VOID* pInfoData);

RTBIBAPI VOID PFAR Cmdd6_set_channel_caption
   (HMDD6 hChannel, USHORT usLen, CHAR* pcCaption);
// String export, no conversation neccesary
#define mdd6_set_channel_caption Cmdd6_set_channel_caption

RTBIBAPI VOID PFAR Cmdd6_get_channel_caption
   (HMDD6 hChannel, USHORT usLen, CHAR* pcCaption);
// String import, no conversation neccesary
#define mdd6_get_channel_caption Cmdd6_get_channel_caption

RTBIBAPI VOID PFAR mdd6_close_channel (HMDD6* phChannel);

RTBIBAPI USHORT PFAR mdd6_get_diagnosis (VOID);

RTBIBAPI USHORT PFAR mdd6_check_handle_valid (HMDD6 hChannel);



/********************************************************************
*  MDD Entry/Exit of MDD services (only for MDD development)
********************************************************************/

RTBIBAPI VOID PFAR mdd6_entry_callback (VOID);
RTBIBAPI VOID PFAR mdd6_exit_callback (VOID);

RTBIBAPI VOID PFAR mdd6_entry_trigger (VOID);
RTBIBAPI VOID PFAR mdd6_exit_trigger (USHORT usError);

RTBIBAPI VOID PFAR mdd6_entry_out_word (VOID);
RTBIBAPI VOID PFAR mdd6_exit_out_word (USHORT usError);

RTBIBAPI VOID PFAR mdd6_entry_out_dword (VOID);
RTBIBAPI VOID PFAR mdd6_exit_out_dword (USHORT usError);

RTBIBAPI VOID PFAR mdd6_entry_out_block (VOID);
RTBIBAPI VOID PFAR mdd6_exit_out_block 
   (USHORT usSizeInfo, USHORT usError);

#define mdd6_entry_out_byte mdd6_entry_out_word
#define mdd6_exit_out_byte mdd6_exit_out_word

#define mdd6_entry_out_short mdd6_entry_out_word
#define mdd6_exit_out_short mdd6_exit_out_word

#define mdd6_entry_in_byte mdd6_entry_trigger
RTBIBAPI VOID PFAR mdd6_exit_in_byte 
   (UCHAR ucData, USHORT usError);

#define mdd6_entry_in_word mdd6_entry_trigger
RTBIBAPI VOID PFAR mdd6_exit_in_word 
   (USHORT usData, USHORT usError);

#define mdd6_entry_in_short mdd6_entry_trigger
RTBIBAPI VOID PFAR mdd6_exit_in_short
   (SHORT sData, USHORT usError);

#define mdd6_entry_in_dword mdd6_entry_trigger
RTBIBAPI VOID PFAR mdd6_exit_in_dword
   (ULONG ulData, USHORT usError);

#define mdd6_entry_in_block mdd6_entry_out_block
#define mdd6_exit_in_block mdd6_exit_out_block

RTBIBAPI VOID PFAR mdd6_entry_special (VOID);
RTBIBAPI VOID PFAR mdd6_exit_special 
   (ULONG ulPar, USHORT usSizeInfo, USHORT usError);

/********************************************************************
*  Channel-Tool
********************************************************************/

RTBIBAPI ULONG PFAR Cml6rt_chm_init_config (CHAR* pacConfigName);
RTBIBAPI ULONG PFAR Cml6rt_chm_open_channel (CHAR* pacChannelName, HMDD6* pHandle);
RTBIBAPI ULONG PFAR Cml6rt_chm_open_channel_callback(char* pacChannelName,
                    HMDD6* pHandle, void* pvCallbackFunction, USHORT usMode, ULONG ulParam);

#define ml6rt_chm_init_config Cml6rt_chm_init_config
#define ml6rt_chm_open_channel Cml6rt_chm_open_channel
#define ml6rt_chm_open_channel_callback Cml6rt_chm_open_channel_callback


/********************************************************************
*  Host adapter
********************************************************************/

RTBIBAPI VOID PFAR ml6rt_set_host_error_handler (ML6_HOST* prcHost);

RTBIBAPI USHORT PFAR ml6rt_install_host (ML6_HOST* prcHost);

RTBIBAPI USHORT PFAR ml6rt_uninstall_host
   (USHORT usHostNr, USHORT usMode);

RTBIBAPI USHORT PFAR ml6rt_get_host_info
   (USHORT usHostNr, USHORT usMode, ML6_HOST* prcHost);



/********************************************************************
*  Standard call of a OsX subroutine
********************************************************************/

RTBIBAPI USHORT PFAR ml6rt_osx_stdcall 
   (USHORT usSubAdr, OSXSTDCALL* prcParIn, OSXSTDCALL* prcParOut);




#endif // !_INC_ML6RTPRO


