/**************************************************************************
*  This header file is included by the header files ML8RTBIB.H
*  and ML6RTBIB.H and ML7RTBIB.H.
*
*  Its purpose is to defines some macros that are faster than the
*  corresponding procedure.
*
*  Defines for Preprocessor:
*  __BORLANDC__         To compile with Borland C compiler. The define
*                       is already done by the compiler.
*
*  Author         HK
*
*  Last change    21/06/00
*                 New macros: mddx_entry_callback, mddx_exit_callback
*                             mlx_entry_function_phys, mlx_exit_function_phys
*
*  Last change    22/09/98  ML7
*
*  Author         Dipl.-Ing. H.Doersam
*
*  Last change    09/04/98
*
*  Copyrights by SORCUS Computer GmbH 1998
*  All rights reserved.
**************************************************************************/




#ifndef _INC_MLXMACRO
#define _INC_MLXMACRO



// Macros only supported by Borland C

#ifdef __BORLANDC__

#pragma inline



// ***** Macros for MODULAR-4/486 (ML8) *****

#ifdef __ML8__

#define _ml8rt_entry() \
                        asm   push  eax; \
                        asm   push  ebx; \
                        asm   push  ecx; \
                        asm   push  edx; \
                        asm   push  edi; \
                        asm   push  esi; \
                        asm   push  es; \
                        asm   push  ds; \
                        asm   push  fs; \
                        asm   push  gs; \
                        asm   mov   ax, DGROUP; \
                        asm   mov   ds, ax

#define _ml8rt_exit() \
                        asm   pop   gs; \
                        asm   pop   fs; \
                        asm   pop   ds; \
                        asm   pop   es; \
                        asm   pop   esi; \
                        asm   pop   edi; \
                        asm   pop   edx; \
                        asm   pop   ecx; \
                        asm   pop   ebx; \
                        asm   pop   eax; \
                        asm   mov   sp, bp; \
                        asm   pop   bp; \
                        asm   clc; \
                        asm   ret

#define _ml8rt_exit_interrupt() \
                        asm   pop   gs; \
                        asm   pop   fs; \
                        asm   pop   ds; \
                        asm   pop   es; \
                        asm   pop   esi; \
                        asm   pop   edi; \
                        asm   pop   edx; \
                        asm   pop   ecx; \
                        asm   pop   ebx; \
                        asm   pop   eax; \
                        asm   mov   sp, bp; \
                        asm   pop   bp; \
                        asm   clc; \
                        asm   iret

#define _ml8rt_entry_function() \
                        asm   sub   sp, 20; \
                        asm   sub   bp, 20; \
                        asm   mov   WORD PTR [bp+18], dx; \
                        asm   mov   WORD PTR [bp+16], di; \
                        asm   shl   eax, 12; \
                        asm   shr   ax, 12; \
                        asm   mov   DWORD PTR [bp+12], eax; \
                        asm   mov   WORD PTR [bp+10], si; \
                        asm   shl   ecx, 12; \
                        asm   shr   cx, 12; \
                        asm   mov   DWORD PTR [bp+6], ecx; \
                        asm   push  edx; \
                        asm   push  es; \
                        asm   push  ds; \
                        asm   mov   ax, DGROUP; \
                        asm   mov   ds, ax

#define _ml8rt_entry_function_phys() \
                        asm   sub   sp, 20; \
                        asm   sub   bp, 20; \
                        asm   mov   WORD PTR [bp+18], dx; \
                        asm   mov   WORD PTR [bp+16], di; \
                        asm   mov   DWORD PTR [bp+12], eax; \
                        asm   mov   WORD PTR [bp+10], si; \
                        asm   mov   DWORD PTR [bp+6], ecx; \
                        asm   push  edx; \
                        asm   push  es; \
                        asm   push  ds; \
                        asm   mov   ax, DGROUP; \
                        asm   mov   ds, ax

#define _ml8rt_exit_function(usUnused,usReturned,usError) \
                        asm   pop   ds; \
                        asm   pop   es; \
                        asm   pop   edx; \
                        _AX   = usError; \
                        _DI   = usUnused; \
                        _SI   = usReturned; \
                        asm   add   bp, 20; \
                        asm   mov   bx, ax; \
                        asm   add   bx, 0xFFFF; \
                        asm   mov   sp, bp; \
                        asm   pop   bp; \
                        asm   ret

#define _ml8rt_exit_function_phys _ml8rt_exit_function

#define _ml8rt_real_adr(x,y) \
                        _EAX  = x; \
                        asm   shl   eax, 12; \
                        asm   shr   ax, 12; \
                        *((ULONG*) y) = _EAX

#define _ml8rt_phys_adr(x,y) \
                        _ECX  = FP_OFF(x); \
                        _EAX  = FP_SEG(x); \
                        asm   shl   eax, 4; \
                        asm   add   eax, ecx; \
                        *((ULONG*) y) = _EAX

#define _ml8rt_disable_interruptible() \
                        asm   pushf; \
                        asm   cli

#define _ml8rt_enable_interruptible() \
                        asm   popf

#define _mdd8_entry_callback() \
                        asm   push  ds; \
                        asm   mov   ax, DGROUP; \
                        asm   mov   ds, ax

#define _mdd8_exit_callback() \
                        asm   pop   ds

#endif // __ML8__

// ***** Macros for MODULAR-4/486 (ML7) *****

#ifdef __ML7__

#define _ml7rt_entry() \
                        asm   push  eax; \
                        asm   push  ebx; \
                        asm   push  ecx; \
                        asm   push  edx; \
                        asm   push  edi; \
                        asm   push  esi; \
                        asm   push  es; \
                        asm   push  ds; \
                        asm   push  fs; \
                        asm   push  gs; \
                        asm   mov   ax, DGROUP; \
                        asm   mov   ds, ax

#define _ml7rt_exit() \
                        asm   pop   gs; \
                        asm   pop   fs; \
                        asm   pop   ds; \
                        asm   pop   es; \
                        asm   pop   esi; \
                        asm   pop   edi; \
                        asm   pop   edx; \
                        asm   pop   ecx; \
                        asm   pop   ebx; \
                        asm   pop   eax; \
                        asm   mov   sp, bp; \
                        asm   pop   bp; \
                        asm   clc; \
                        asm   ret

#define _ml7rt_exit_interrupt() \
                        asm   pop   gs; \
                        asm   pop   fs; \
                        asm   pop   ds; \
                        asm   pop   es; \
                        asm   pop   esi; \
                        asm   pop   edi; \
                        asm   pop   edx; \
                        asm   pop   ecx; \
                        asm   pop   ebx; \
                        asm   pop   eax; \
                        asm   mov   sp, bp; \
                        asm   pop   bp; \
                        asm   clc; \
                        asm   iret

#define _ml7rt_entry_function() \
                        asm   sub   sp, 20; \
                        asm   sub   bp, 20; \
                        asm   mov   WORD PTR [bp+18], dx; \
                        asm   mov   WORD PTR [bp+16], di; \
                        asm   shl   eax, 12; \
                        asm   shr   ax, 12; \
                        asm   mov   DWORD PTR [bp+12], eax; \
                        asm   mov   WORD PTR [bp+10], si; \
                        asm   shl   ecx, 12; \
                        asm   shr   cx, 12; \
                        asm   mov   DWORD PTR [bp+6], ecx; \
                        asm   push  edx; \
                        asm   push  es; \
                        asm   push  ds; \
                        asm   mov   ax, DGROUP; \
                        asm   mov   ds, ax

#define _ml7rt_entry_function_phys() \
                        asm   sub   sp, 20; \
                        asm   sub   bp, 20; \
                        asm   mov   WORD PTR [bp+18], dx; \
                        asm   mov   WORD PTR [bp+16], di; \
                        asm   mov   DWORD PTR [bp+12], eax; \
                        asm   mov   WORD PTR [bp+10], si; \
                        asm   mov   DWORD PTR [bp+6], ecx; \
                        asm   push  edx; \
                        asm   push  es; \
                        asm   push  ds; \
                        asm   mov   ax, DGROUP; \
                        asm   mov   ds, ax

#define _ml7rt_exit_function(usUnused,usReturned,usError) \
                        asm   pop   ds; \
                        asm   pop   es; \
                        asm   pop   edx; \
                        _AX   = usError; \
                        _DI   = usUnused; \
                        _SI   = usReturned; \
                        asm   add   bp, 20; \
                        asm   mov   bx, ax; \
                        asm   add   bx, 0xFFFF; \
                        asm   mov   sp, bp; \
                        asm   pop   bp; \
                        asm   ret

#define _ml7rt_exit_function_phys _ml7rt_exit_function

#define _ml7rt_real_adr(x,y) \
                        _EAX  = x; \
                        asm   shl   eax, 12; \
                        asm   shr   ax, 12; \
                        *((ULONG*) y) = _EAX

#define _ml7rt_phys_adr(x,y) \
                        _ECX  = FP_OFF(x); \
                        _EAX  = FP_SEG(x); \
                        asm   shl   eax, 4; \
                        asm   add   eax, ecx; \
                        *((ULONG*) y) = _EAX

#define _ml7rt_disable_interruptible() \
                        asm   pushf; \
                        asm   cli

#define _ml7rt_enable_interruptible() \
                        asm   popf

#define _mdd7_entry_callback() \
                        asm   push  ds; \
                        asm   mov   ax, DGROUP; \
                        asm   mov   ds, ax

#define _mdd7_exit_callback() \
                        asm   pop   ds

#endif // __ML7__



// ***** Macros for Multi-COM (ML6) *****

#ifdef __ML6__

#define _ml6rt_entry() \
                        asm   push  eax; \
                        asm   push  ebx; \
                        asm   push  ecx; \
                        asm   push  edx; \
                        asm   push  edi; \
                        asm   push  esi; \
                        asm   push  es; \
                        asm   push  ds; \
                        asm   push  fs; \
                        asm   push  gs; \
                        asm   mov   ax, DGROUP; \
                        asm   mov   ds, ax

#define _ml6rt_exit() \
                        asm   pop   gs; \
                        asm   pop   fs; \
                        asm   pop   ds; \
                        asm   pop   es; \
                        asm   pop   esi; \
                        asm   pop   edi; \
                        asm   pop   edx; \
                        asm   pop   ecx; \
                        asm   pop   ebx; \
                        asm   pop   eax; \
                        asm   mov   sp, bp; \
                        asm   pop   bp; \
                        asm   clc; \
                        asm   ret

#define _ml6rt_exit_interrupt() \
                        asm   pop   gs; \
                        asm   pop   fs; \
                        asm   pop   ds; \
                        asm   pop   es; \
                        asm   pop   esi; \
                        asm   pop   edi; \
                        asm   pop   edx; \
                        asm   pop   ecx; \
                        asm   pop   ebx; \
                        asm   pop   eax; \
                        asm   mov   sp, bp; \
                        asm   pop   bp; \
                        asm   clc; \
                        asm   iret

#define _ml6rt_entry_function() \
                        asm   sub   sp, 20; \
                        asm   sub   bp, 20; \
                        asm   mov   WORD PTR [bp+18], dx; \
                        asm   mov   WORD PTR [bp+16], di; \
                        asm   shl   eax, 12; \
                        asm   shr   ax, 12; \
                        asm   mov   DWORD PTR [bp+12], eax; \
                        asm   mov   WORD PTR [bp+10], si; \
                        asm   shl   ecx, 12; \
                        asm   shr   cx, 12; \
                        asm   mov   DWORD PTR [bp+6], ecx; \
                        asm   push  edx; \
                        asm   push  es; \
                        asm   push  ds; \
                        asm   mov   ax, DGROUP; \
                        asm   mov   ds, ax

#define _ml6rt_entry_function_phys() \
                        asm   sub   sp, 20; \
                        asm   sub   bp, 20; \
                        asm   mov   WORD PTR [bp+18], dx; \
                        asm   mov   WORD PTR [bp+16], di; \
                        asm   mov   DWORD PTR [bp+12], eax; \
                        asm   mov   WORD PTR [bp+10], si; \
                        asm   mov   DWORD PTR [bp+6], ecx; \
                        asm   push  edx; \
                        asm   push  es; \
                        asm   push  ds; \
                        asm   mov   ax, DGROUP; \
                        asm   mov   ds, ax

#define _ml6rt_exit_function(usUnused,usReturned,usError) \
                        asm   pop   ds; \
                        asm   pop   es; \
                        asm   pop   edx; \
                        _AX   = usError; \
                        _DI   = usUnused; \
                        _SI   = usReturned; \
                        asm   add   bp, 20; \
                        asm   mov   bx, ax; \
                        asm   add   bx, 0xFFFF; \
                        asm   mov   sp, bp; \
                        asm   pop   bp; \
                        asm   ret
#define _ml6rt_exit_function_phys _ml6rt_exit_function

#define _ml6rt_real_adr(x,y) \
                        _EAX  = x; \
                        asm   shl   eax, 12; \
                        asm   shr   ax, 12; \
                        *((ULONG*) y) = _EAX

#define _ml6rt_phys_adr(x,y) \
                        _ECX  = FP_OFF(x); \
                        _EAX  = FP_SEG(x); \
                        asm   shl   eax, 4; \
                        asm   add   eax, ecx; \
                        *((ULONG*) y) = _EAX

#define _ml6rt_disable_interruptible() \
                        asm   pushf; \
                        asm   cli

#define _ml6rt_enable_interruptible() \
                        asm   popf

#define _mdd6_entry_callback() \
                        asm   push  ds; \
                        asm   mov   ax, DGROUP; \
                        asm   mov   ds, ax

#define _mdd6_exit_callback() \
                        asm   pop   ds

#endif // __ML6__




#endif // __BORLANDC__





#endif // !_INC_MLXMACRO
